
proc toolbar {w args}\
{
	eval frame $w -class Toolbar
	rename $w $w.frame
	pack [frame $w.f] 
	proc $w {method args} "return \[eval toolbar__method__\$method $w \$args\]"
	toolbar__configure
	option add *Toolbutton*relief flat
	return $w
}


proc toolbar__method__unselectall {but}\
{
	set w [join [lrange [split $but "."] 0 2] "."]
	global opt$w
	foreach but [keylkeys opt$w]\
	{
		catch {[keylget opt$w $but.-parent].$but.b configure \
			-relief [keylget opt$w $but.-relief]
		}
	}
}

proc toolbar__method__select {}\
{
	global opt
	foreach but [keylkeys opt]\
	{
		catch {[keylget opt $but.-parent].$but.b configure \
			-relief [keylget opt $but.-relief]
		}
	}
}

proc toolbar__method__get {w args}\
{
	global opt$w
	foreach but [keylkeys opt$w]\
	{
		if {[[keylget opt$w $but.-parent].$but.b cget -relief] == "sunken"}\
		{
			return [keylget opt$w $but.-parent].$but.b
		}
	}
	return -1	
}

proc toolbar__method__addbutton {w args}\
{
	global opt$w
	set x [crange $w 1 end]
	set row 1
	set column 1
	set relief flat
	set cargs ""
	while {[llength $args] >= 2}\
	{
		set option  [lindex $args 0]
		set value [lindex $args 1]
		set args [lrange $args 2 end]
		switch -exact -- $option \
		{
			-row {
				set row $value
			}
			-column {
				set column $value
			}
			-cursor {
				set cursor $value
			}
			default {
				lappend cargs $option $value
			}
		}
	}
	if {"$args" != {}}\
	{
		error "unmatched $args"
	}
	if {[winfo exists $w.f.$row$column]}\
	{
		error "A button is already present in row $row and column $column"
		return
	}
	set num $row$column
	keylset opt$w $num.-row $row 
	keylset opt$w $num.-column $column 
	keylset opt$w $num.-parent $w.f
	keylset opt$w $num.-relief $relief
	if {[info exists cursor]}\
	{	keylset opt$w $num.-cursor $cursor
	}
	frame $w.f.$num -class Toolbutton -relief raised -borderwidth 2
	grid configure $w.f.$num -row $row \
		-column $column
	eval toolbutton $w.f.$num.b $cargs
	pack $w.f.$num.b 
	while {[llength $cargs] >= 2}\
	{
		keylset opt$w $num.[lindex $cargs 0] [lindex $cargs 1]
		set cargs [lrange $cargs 2 end]
	}
	return $w.f.$num.b
}

proc toolbar__method__cget {w args}\
{
	$w.f cget $args
}

proc toolbar__method__configure {w args}\
{
	eval $w.f configure $args
}

proc toolbar__configure {}\
{
	upvar w w
	upvar args args
	eval $w.f configure $args
}
